unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, StdCtrls;

type
  TForm1 = class(TForm)
    BtnPlot: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    procedure BtnPlotClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Math;

procedure TForm1.BtnPlotClick(Sender: TObject);

var
  ii     : Integer;
  XData,
  YData  : Array of Double;

begin
  Series1.Clear;
  Series1.TreatNulls := tnIgnore; //TTreatNullsStyle = (tnDontPaint, tnSkip, tnIgnore);
  SetLength(XData,100);
  SetLength(YData,100);
  for ii := 0 to High(XData) do begin
    XData[ii] := ii;
    YData[ii] := 2*ii;
  end;
  YData[50] := NaN; //comment this line out and it works
  with Series1.XValues do begin
    Value    := TChartValues(XData);
    Count    := Length(XData);
    Modified :=True;
  end;
  with Series1.YValues do begin
    Value    := TChartValues(YData);
    Count    := Length(YData);
    Modified := True;
  end;
  for ii := 0 to High(YData) do begin
    if IsNaN(YData[ii]) then begin
      Series1.SetNull(ii);
    end;
  end;
  Series1.Repaint;      
end;

end.
